/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-jsk-recognition-msgs-0.3.6-0precise-20150911-0859/msg/SparseOccupancyGridColumn.msg
 *
 */


#ifndef JSK_RECOGNITION_MSGS_MESSAGE_SPARSEOCCUPANCYGRIDCOLUMN_H
#define JSK_RECOGNITION_MSGS_MESSAGE_SPARSEOCCUPANCYGRIDCOLUMN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <jsk_recognition_msgs/SparseOccupancyGridCell.h>

namespace jsk_recognition_msgs
{
template <class ContainerAllocator>
struct SparseOccupancyGridColumn_
{
  typedef SparseOccupancyGridColumn_<ContainerAllocator> Type;

  SparseOccupancyGridColumn_()
    : column_index(0)
    , cells()  {
    }
  SparseOccupancyGridColumn_(const ContainerAllocator& _alloc)
    : column_index(0)
    , cells(_alloc)  {
    }



   typedef int32_t _column_index_type;
  _column_index_type column_index;

   typedef std::vector< ::jsk_recognition_msgs::SparseOccupancyGridCell_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::jsk_recognition_msgs::SparseOccupancyGridCell_<ContainerAllocator> >::other >  _cells_type;
  _cells_type cells;




  typedef boost::shared_ptr< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SparseOccupancyGridColumn_

typedef ::jsk_recognition_msgs::SparseOccupancyGridColumn_<std::allocator<void> > SparseOccupancyGridColumn;

typedef boost::shared_ptr< ::jsk_recognition_msgs::SparseOccupancyGridColumn > SparseOccupancyGridColumnPtr;
typedef boost::shared_ptr< ::jsk_recognition_msgs::SparseOccupancyGridColumn const> SparseOccupancyGridColumnConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_recognition_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'jsk_recognition_msgs': ['/tmp/buildd/ros-hydro-jsk-recognition-msgs-0.3.6-0precise-20150911-0859/msg'], 'pcl_msgs': ['/opt/ros/hydro/share/pcl_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
{
  static const char* value()
  {
    return "55074b193e722d5ead092ffe27f06522";
  }

  static const char* value(const ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x55074b193e722d5eULL;
  static const uint64_t static_value2 = 0xad092ffe27f06522ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_recognition_msgs/SparseOccupancyGridColumn";
  }

  static const char* value(const ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 column_index\n\
SparseOccupancyGridCell[] cells\n\
\n\
================================================================================\n\
MSG: jsk_recognition_msgs/SparseOccupancyGridCell\n\
int32 row_index\n\
float32 value\n\
";
  }

  static const char* value(const ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.column_index);
      stream.next(m.cells);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SparseOccupancyGridColumn_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_recognition_msgs::SparseOccupancyGridColumn_<ContainerAllocator>& v)
  {
    s << indent << "column_index: ";
    Printer<int32_t>::stream(s, indent + "  ", v.column_index);
    s << indent << "cells[]" << std::endl;
    for (size_t i = 0; i < v.cells.size(); ++i)
    {
      s << indent << "  cells[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::jsk_recognition_msgs::SparseOccupancyGridCell_<ContainerAllocator> >::stream(s, indent + "    ", v.cells[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_RECOGNITION_MSGS_MESSAGE_SPARSEOCCUPANCYGRIDCOLUMN_H
